#define VERSION "0.2"

#pragma semicolon 1

#include <sdktools>
#include <steamtools>
#include <sdkhooks>
#include <cstrike>


new iAccount = -1;
new sm_difficulty = 1;

new SmokeMonster[MAXPLAYERS+1] = false;

new Float:OldRoundTime = 0.0;
new Float:LimitTeams = 0.0;
new Float:StartMoney = 0.0;
new Teambalance = 0;

new Handle:sm_app;
new sm_app_value = 0;
 
public Plugin:myinfo =
{
	name = "[CS:S] Lost: Smoke Monster Endurance",
	author = "Oshizu",
	description = "Gamemode Based on J. J. Abrams 'Lost' series.",
	version = VERSION,
	url = "..."
}

public OnPluginStart()
{
	iAccount = FindSendPropOffs("CCSPlayer", "m_iAccount");
	if (iAccount == -1)
	{
		SetFailState("[LOST] 4 8 15 16 23 42 can't find m_iAccount offset");
	}

	sm_app = CreateConVar("sm_lost_smoke_monster_appearance",	"0", "Changes how smoke monster looks \n0: Shows black painted playermodel & Smoke Trail \n1: Shows only Smoke Trail");
	HookConVarChange(sm_app, OnSMAChanged);
	
	RegConsoleCmd("buy", BuyRestrictions);
	RegConsoleCmd("autobuy", BuyRestrictions);
	RegConsoleCmd("rebuy", BuyRestrictions);
	
	HookEvent("player_death", player_death);
	HookEvent("player_death", player_death_pre, EventHookMode_Pre);
	HookEvent("player_spawn", player_spawn);
	HookEvent("round_start", round_start);
	HookEvent("round_end", round_end);
	AddCommandListener(NoDeath, "kill");
	AddCommandListener(NoDeath, "explode");
	AddCommandListener(JoinTeam, "jointeam");
	
	CreateTimer(1.0, PlayersInTeams, _, TIMER_REPEAT);
	AutoExecConfig(true);
}

public Action:PlayersInTeams(Handle:timer)
{
	new ply_t = 0;
	new minply = GetClientCount(true);
	if(minply >= 2)
	{
		for(new i = 1; i <= MaxClients; i++)
		{
			if(i > 0 && IsClientInGame(i))
			{
				if(GetClientTeam(i) == 2)
				{
					ply_t++;
				}
			}
		}
		if(ply_t == 0)
		{
			new player = GetRandomPlayer(3);
			SmokeMonster[player] = true;
			CS_SwitchTeam(player, 2);
		}
	}
}

public OnConfigsExecuted()
{
	OldRoundTime = GetConVarFloat(FindConVar("mp_roundtime"));
	SetConVarBounds(FindConVar("mp_roundtime"), ConVarBound_Upper, true, 30.0);
	SetConVarFloat(FindConVar("mp_roundtime"), 13.0);
	
	StartMoney = GetConVarFloat(FindConVar("mp_startmoney"));
	SetConVarFloat(FindConVar("mp_startmoney"), 14815.162342);
	
	LimitTeams = GetConVarFloat(FindConVar("mp_limitteams"));
	SetConVarBounds(FindConVar("mp_limitteams"), ConVarBound_Upper, true, 65.0);
	SetConVarFloat(FindConVar("mp_limitteams"), 65.0);
	
	Teambalance = GetConVarInt(FindConVar("mp_autoteambalance"));
	SetConVarInt(FindConVar("mp_autoteambalance"), 0);

	decl String:mod_version[64];
	Format(mod_version, 64, "Lost: SME %s", VERSION);
	Steam_SetGameDescription(mod_version);
}

public OnPluginEnd()
{
	SetConVarFloat(FindConVar("mp_roundtime"), OldRoundTime);
	
	SetConVarFloat(FindConVar("mp_startmoney"), StartMoney);
	
	SetConVarFloat(FindConVar("mp_limitteams"), LimitTeams);
	
	SetConVarInt(FindConVar("mp_autoteambalance"), Teambalance);
}

public OnMapStart()
{
	sm_difficulty = 1;

	PrecacheSound("lost/lst_player_killed.wav", true);
	PrecacheSound("lost/lst_smokeloop.wav", true);
	PrecacheSound("lost/lst_survivors_win.wav", true);
	PrecacheSound("lost/lst_smoke_win.wav", true);
	PrecacheDecal("lost/sm_screen", true);
	
	AddFileToDownloadsTable("materials/lost/sm_screen.vtf");
	AddFileToDownloadsTable("materials/lost/sm_screen_normal.vtf");
	AddFileToDownloadsTable("materials/lost/sm_screen.vmt");
	AddFileToDownloadsTable("sound/lost/lst_player_killed.wav");
	AddFileToDownloadsTable("sound/lost/lst_smokeloop.wav");
	AddFileToDownloadsTable("sound/lost/lst_survivors_win.wav");
	AddFileToDownloadsTable("sound/lost/lst_smoke_win.wav");
}

public Action:JoinTeam(client, const String:command[], args)
{
	if (args == 0)
	{
		return Plugin_Continue;
	}
  
	new int_arg;
	new String:arg[32];  
	GetCmdArg(1, arg, sizeof(arg));
	int_arg = StringToInt(arg);
	
	if(int_arg == 2)
	{
		if(GetClientTeam(client) == 2)
		{
			return Plugin_Handled;
		}
		else
		{
			new smoketeam_count = GetTeamClientCount(2);
			if (smoketeam_count >= 1)
			{
				PrintToChat(client, "\x05[LOST]\x01  You can't join Smoke Monster team.");
				return Plugin_Handled;
			}
		}
	}
	else if(int_arg == 3)
	{
		if(GetClientTeam(client) == 3)
		{
			return Plugin_Handled;
		}
	}
	return Plugin_Continue;
}

public OnSMAChanged(Handle:cvar, const String:oldVal[], const String:newVal[])
{
	if (StringToInt(newVal) == 1)
	{
		sm_app_value = 1;
	}
	else if (StringToInt(newVal) == 0)
	{
		sm_app_value = 0;
	}
	else if (StringToInt(newVal) < 0)
	{
		SetConVarInt(cvar, 0);
		sm_app_value = 0;
	}
	else if (StringToInt(newVal) > 1)
	{
		SetConVarInt(cvar, 1);
		sm_app_value = 1;
	}
}


public Action:BuyRestrictions(client, argc)
{
	if(GetClientTeam(client) == 2)
	{
		PrintToChat(client, "\x05[LOST]\x01  You can't buy equipment as Smoke Monster");
		
		return Plugin_Handled;
	}
	else if(GetClientTeam(client) == 3)
	{
		decl String:weapon[64];
		GetCmdArg(1, weapon, sizeof(weapon));
		
		if(StrEqual(weapon, "m249"))
		{
			PrintToChat(client, "\x05[LOST]\x01 m249 is not obtainable equipment on Island");
			return Plugin_Handled;
		}
		else if(StrEqual(weapon, "smokegrenade"))
		{
			PrintToChat(client, "\x05[LOST]\x01  Smoke Grenade is not obtainable equipment on Island");
			return Plugin_Handled;
		}
		else if(StrEqual(weapon, "defuser"))
		{
			PrintToChat(client, "\x05[LOST]\x01  Defuse Kit is not obtainable equipment on Island");
			return Plugin_Handled;
		}
		else if(StrEqual(weapon, "nvgs"))
		{
			PrintToChat(client, "\x05[LOST]\x01  Nightvision Googles are not obtainable equipment on Island");
			return Plugin_Handled;
		}
		return Plugin_Continue;
	}
	return Plugin_Continue;
}

public OnClientPutInServer(client) 
{ 
	SDKHook(client, SDKHook_WeaponCanUse, OnPickupWep);
	SDKHook(client, SDKHook_OnTakeDamage, OnClientTakeDamage);
}

public Action:OnClientTakeDamage(client, &attacker, &inflictor, &Float:damage, &damagetype, &weapon, Float:damageForce[3], Float:damagePosition[3])
{
	if(client > 0)
	{
		if(attacker > 0)
		{
			if(IsClientInGame(client))
			{
				if(IsClientInGame(attacker))
				{
					if(GetClientTeam(attacker) == 2 && GetClientTeam(client) == 3)
					{
						if(sm_difficulty == 1)
						{
							damage = 65.0;
							return Plugin_Changed;
						}
						else if(sm_difficulty == 2)
						{
							damage = 110.0;
							return Plugin_Changed;
						}
						else if(sm_difficulty == 3)
						{
							damage = 120.0;
							return Plugin_Changed;
						}
						else if(sm_difficulty == 4)
						{
							damage = 130.0;
							return Plugin_Changed;
						}
						else if(sm_difficulty == 5)
						{
							damage = 140.0;
							return Plugin_Changed;
						}
					}
					else if(GetClientTeam(attacker) == 3 && GetClientTeam(client) == 2)
					{
						new SMAHP = GetClientHealth(client);
						PrintHintTextToAll("Smoke Monster Health: %i", SMAHP);
						return Plugin_Changed;
					}
				}
			}
		}
		return Plugin_Continue;
	}
	return Plugin_Continue;
}

public OnClientDisconnect(client)
{ 
	if(IsClientInGame(client))
	{
		SDKUnhook(client, SDKHook_WeaponCanUse, OnPickupWep);
	}
}

public Action:OnPickupWep(client, weapon)
{
	if(GetClientTeam(client) == 2)
	{
		new String:WeaponString[64];
		GetEdictClassname(weapon, WeaponString, sizeof(WeaponString)); 
		if(StrEqual(WeaponString, "weapon_knife"))
		{
			return Plugin_Continue;
		}
		else
		{
			return Plugin_Handled;
		}
	}
	return Plugin_Continue;
}



SmokeMonsterTrail(player)
{
	new String:tName[128];
	new entity = CreateEntityByName("env_steam");
	if(IsValidEdict(entity))
	{

		new Float:pos[3];
		new Float:ang[3];
		GetClientAbsOrigin(player, pos);
		GetClientAbsAngles(player, ang);
		pos[0] -= 30;
//		pos[1] -= 30;
		pos[2] -= 20;
		TeleportEntity(entity, pos, ang, NULL_VECTOR);
	
		Format(tName, sizeof(tName), "target%i", player);
		DispatchKeyValue(player, "targetname", tName);

		DispatchKeyValue(entity, "parentname", tName);
	//	DispatchKeyValue(entity, "SpawnFlags", "1");
		DispatchKeyValue(entity, "angles", "0 0 0");
	//	DispatchKeyValue(entity, "rendercolor", "26 26 26");
		DispatchKeyValue(entity, "rendercolor", "0 0 0");
		DispatchKeyValue(entity, "SpreadSpeed", "15");
		DispatchKeyValue(entity, "Speed", "120");
		DispatchKeyValue(entity, "StartSize", "15");
		DispatchKeyValue(entity, "EndSize", "45");
		DispatchKeyValue(entity, "Rate", "26");
		DispatchKeyValue(entity, "JetLength", "150");
		DispatchKeyValue(entity, "renderamt", "255");
		DispatchKeyValue(entity, "InitialState", "1");
		DispatchSpawn(entity);
		SetVariantString(tName);
		AcceptEntityInput(entity, "SetParent", entity, entity, 0);
		SetVariantString("forward");
		AcceptEntityInput(entity, "SetParentAttachmentMaintainOffset", entity, entity, 0);
		AcceptEntityInput(entity, "TurnOn");
	}
}


public round_start(Handle:event, const String:name[], bool:dontBroadcast) 
{
	if(sm_difficulty == 1)
	{
		PrintToChatAll("\x05[LOST]\x01  Smoke Monster Difficulty Level: Very Easy");
	}
	else if(sm_difficulty == 2)
	{
		PrintToChatAll("\x05[LOST]\x01  Smoke Monster Difficulty Level: Easy");
	}
	else if(sm_difficulty == 3)
	{
		PrintToChatAll("\x05[LOST]\x01  Smoke Monster Difficulty Level: Normal");
	}
	else if(sm_difficulty == 4)
	{
		PrintToChatAll("\x05[LOST]\x01  Smoke Monster Difficulty Level: Hard");
	}
	else if(sm_difficulty == 5)
	{
		PrintToChatAll("\x05[LOST]\x01  Smoke Monster Difficulty Level: Very Hard");
	}
}


public round_end(Handle:event, const String:name[], bool:dontBroadcast) 
{
	new winner = GetEventInt(event, "winner");
	if(winner == 2)
	{
		sm_difficulty = 1;
		PrintToChatAll("\x05[LOST]\x01  You has been killed. Smoke Monster level has been reset back to Easy");
		EmitSoundToAll("lost/lst_smoke_win.wav", SOUND_FROM_PLAYER, SNDCHAN_AUTO, SNDLEVEL_TRAIN);
	}
	else if(winner == 3)
	{
		for(new i = 1; i <= MaxClients; i++)
		{
			if(i > 0 && IsClientInGame(i))
			{
				if(GetClientTeam(i) == 3)
				{
					new OldMoney = GetEntData(i, iAccount);
					new Money = OldMoney + 4815;
					PrintToChat(i, "\x05[LOST]\x01  You earned 4815$ for killing Smoke Monster");
					SetEntData(i, iAccount, Money);
				}
			}
		}
	}
	for(new i = 1; i <= MaxClients; i++)
	{
		if(i > 0)
		{
			if(IsClientInGame(i))
			{
				SmokeMonster[i] = false;
				if(GetClientTeam(i) == 2)
				{
					CS_SwitchTeam(i, 3);
				}
			}
		}
	}
	new sm = GetRandomPlayer(3);
	if(sm > 0)
	{
		SmokeMonster[sm] = true;
		CreateTimer(0.00, ChangeTeamOfSmoke, sm);
	}
}

public Action:ChangeTeamOfSmoke(Handle:timer, any:client)
{
	if(client > 0)
	{
		CS_SwitchTeam(client, 2);
		ForcePlayerSuicide(client);
	}
}

public player_death_pre(Handle:event, const String:name[], bool:dontBroadcast) 
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	new attacker = GetClientOfUserId(GetEventInt(event, "attacker"));
	
	if(client > 0)
	{
		if(attacker > 0)
		{
			if (GetClientTeam(client) == 3) 
			{
				if(GetClientTeam(attacker) == 2)
				{
					SetEventString(event, "weapon", "d_skull_cs");
				}
			}
		}
	}
}

public player_death(Handle:event, const String:name[], bool:dontBroadcast) 
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	new attacker = GetClientOfUserId(GetEventInt(event, "attacker"));
	
	if(client > 0)
	{
		if(attacker > 0)
		{
			if (GetClientTeam(client) == 3) 
			{
				if(GetClientTeam(attacker) == 2)
				{
					EmitSoundToAll("lost/lst_player_killed.wav", attacker, SNDCHAN_AUTO, SNDLEVEL_TRAIN);
					if(sm_difficulty == 1)
					{
						new health = GetClientHealth(attacker) + 100;
						SetEntityHealth(attacker, health);
					}
					else if(sm_difficulty == 2)
					{
						new health = GetClientHealth(attacker) + 150;
						SetEntityHealth(attacker, health);
					}
					else if(sm_difficulty == 3)
					{
						new health = GetClientHealth(attacker) + 300;
						SetEntityHealth(attacker, health);
					}
					else if(sm_difficulty == 4)
					{
						new health = GetClientHealth(attacker) + 400;
						SetEntityHealth(attacker, health);
					}
					else if(sm_difficulty == 5)
					{
						new health = GetClientHealth(attacker) + 500;
						SetEntityHealth(attacker, health);
					}
				}
			}
			else if (GetClientTeam(client) == 2) 
			{
				EmitSoundToAll("lost/lst_survivors_win.wav", SOUND_FROM_PLAYER, SNDCHAN_AUTO, SNDLEVEL_NORMAL);
				if(GetClientTeam(attacker) == 3)
				{
					if(sm_difficulty == 5)
					{
						sm_difficulty = 1;
						PrintToChatAll("\x05[LOST]\x01  Final Smoke Monster has been defeated resetting level back to 1.");
					}
					else
					{
						sm_difficulty++;
					}
				}
			}
		}
	}
}

public player_spawn(Handle:event, const String:name[], bool:dontBroadcast) 
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if (!client) return; // Error-checking
	if (GetClientTeam(client) == 3) 
	{
		Overlay(client, "none"); // Disables Overlay if player was before Smoke Monster
		SetEntityRenderColor(client, 255, 255, 255, 255) ;
		SetEntityGravity(client, 1.00);
	}
	else if (GetClientTeam(client) == 2) 
	{
		if(SmokeMonster[client])
		{
			if(sm_app_value == 0)
			{
				SetEntityRenderMode(client, RENDER_TRANSALPHA) ;
				SetEntityRenderColor(client, 0, 0, 0, 255);
			}
			else
			{
				SetEntityRenderMode(client, RENDER_TRANSALPHA);
				SetEntityRenderColor(client, 0, 0, 0, 0);
			}

			CreateTimer(0.00, SmokeMonsterSpawn, any:client);
	
	//		RemoveAllPlayersWeapons(client);
	
			new knife = GetPlayerWeaponSlot(client, 2);
			if (IsValidEntity(knife))
			{
				SetEntityRenderMode(knife, RENDER_TRANSALPHA);
				SetEntityRenderColor(knife, 255, 255, 255, 0);
			}
		}
		else
		{
			ForcePlayerSuicide(client);
			CS_SwitchTeam(client, 3);
		}
	}
}

public Action:SmokeMonsterSpawn(Handle:timer, any:client)
{
	EmitSoundToAll("lost/lst_smokeloop.wav", client, SNDCHAN_AUTO, SNDLEVEL_SCREAMING);
	Overlay(client, "lost/sm_screen");
	SmokeMonsterTrail(client);
	new hpmultiplier = GetClientCount();
	new basehp = 600 * hpmultiplier;
	if(sm_difficulty == 1)
	{
		SetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue", 1.10);
	}
	else if(sm_difficulty == 2)
	{
		basehp *= 2;
		SetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue", 1.15);
	}
	else if(sm_difficulty == 3)
	{
		basehp *= 3;
		SetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue", 1.20);
	}
	else if (sm_difficulty == 4)
	{
		basehp *= 4;
		SetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue", 1.25);
	}
	else if (sm_difficulty == 5)
	{
		basehp *= 5;
		SetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue", 1.30);
	}
	
	SetEntityHealth(client, basehp);
}

public OnGameFrame()
{
	for(new i = 1; i <= MaxClients; i++)
	{
		if(IsClientInGame(i))
		{
			if(GetClientTeam(i) == 2)
			{
				SetEntityGravity(i, 0.20);
				Overlay(i, "lost/sm_screen");
			}
		}
	}
}

public Action:NoDeath(client, const String:command[], args)
{
	PrintToChat(client, "\x05[LOST]\x01  You can't suicide!");
	return Plugin_Handled;
}

// stocks

stock GetRandomPlayer(team)
{
	new clients[MaxClients+1], clientCount;
	for (new i = 1; i <= MaxClients; i++)
		if (IsClientInGame(i) && (GetClientTeam(i) == team))
		clients[clientCount++] = i;
	return (clientCount == 0) ? -1 : clients[GetRandomInt(0, clientCount-1)];
}

stock Overlay(client, String:material[] = "")
{
	if (IsClientInGame(client) && !IsFakeClient(client))
	{
		new iFlags = GetCommandFlags("r_screenoverlay");
		SetCommandFlags("r_screenoverlay", iFlags & ~FCVAR_CHEAT);
		if (!StrEqual(material, "")) ClientCommand(client, "r_screenoverlay \"%s\"", material);
		else ClientCommand(client, "r_screenoverlay \"\"");
		SetCommandFlags("r_screenoverlay", iFlags);
	}
}